declare module '@gm5/core' {
  import { Server } from 'http'

  interface Middleware {
    (req: Request, res: Response, next: () => void): void
  }

  interface Installable {
    name: string
    install: (args: any) => any
  }

  class Five {
    get server(): Server

    set(obj: object): this

    get(key: string): any

    use(middleware: Middleware | Installable, args?: any): this

    install(module: Installable, args: any): this

    preload(dir: string): this

    listen(port?: number, callback?: () => void): this
  }

  export function createApp(conf?: object): Five
}
